VTK: vtkStaticCellLocator Class Reference

| VTK 9.3.1

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
vtkStaticCellLocator Class Reference

perform fast cell location operations More...

`#include <vtkStaticCellLocator.h>`

Inheritance diagram for vtkStaticCellLocator:
[legend]
Collaboration diagram for vtkStaticCellLocator:
[legend]

## Public Member Functions
bool | GetLargeIds ()
| Inform the user as to whether large ids are being used. More...
int | IntersectWithLine (const double a0[3], const double a1[3], double tol, double &t, double x[3], double pcoords[3], int &subId, vtkIdType &cellId, vtkGenericCell *cell) override
| Return intersection point (if any) AND the cell which was intersected by the finite line. More...
int | IntersectWithLine (const double p1[3], const double p2[3], double tol, vtkPoints *points, vtkIdList *cellIds, vtkGenericCell *cell) override
| Take the passed line segment and intersect it with the data set. More...
void | FindClosestPoint (const double x[3], double closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, double &dist2) override
| Return the closest point and the cell which is closest to the point x. More...
vtkIdType | FindClosestPointWithinRadius (double x[3], double radius, double closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, double &dist2, int &inside) override
| Return the closest point within a specified radius and the cell which is closest to the point x. More...
void | FindCellsWithinBounds (double *bbox, vtkIdList *cells) override
| Return a list of unique cell ids inside of a given bounding box. More...
void | FindCellsAlongLine (const double p1[3], const double p2[3], double tolerance, vtkIdList *cellsIds) override
| Take the passed line segment and intersect it with the data set. More...
void | FindCellsAlongPlane (const double o[3], const double n[3], double tolerance, vtkIdList *cells) override
| Take the passed line segment and intersect it with the data set. More...
vtkIdType | FindCell (double x[3], double vtkNotUsed(tol2), vtkGenericCell *GenCell, int &subId, double pcoords[3], double *weights) override
| Find the cell containing a given point. More...
bool | InsideCellBounds (double x[3], vtkIdType cellId) override
| Quickly test if a point is inside the bounds of a particular cell. More...
void | ShallowCopy (vtkAbstractCellLocator *locator) override
| Shallow copy of a vtkStaticCellLocator. More...
virtual vtkIdType | FindCell (double x[3])
| Returns the Id of the cell containing the point, returns -1 if no cell found. More...
virtual vtkIdType | FindCell (double x[3], double tol2, vtkGenericCell *GenCell, double pcoords[3], double *weights)
| Find the cell containing a given point. More...
virtual vtkIdType | FindCell (double x[3], double tol2, vtkGenericCell *GenCell, int &subId, double pcoords[3], double *weights)
virtual void | FindClosestPoint (const double x[3], double closestPoint[3], vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point and the cell which is closest to the point x. More...
virtual void | FindClosestPoint (const double x[3], double closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point and the cell which is closest to the point x. More...
virtual vtkIdType | FindClosestPointWithinRadius (double x[3], double radius, double closestPoint[3], vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point within a specified radius and the cell which is closest to the point x. More...
virtual vtkIdType | FindClosestPointWithinRadius (double x[3], double radius, double closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point within a specified radius and the cell which is closest to the point x. More...
virtual vtkIdType | FindClosestPointWithinRadius (double x[3], double radius, double closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, double &dist2, int &inside)
| Return the closest point within a specified radius and the cell which is closest to the point x. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId)
| Return intersection point (if any) of finite line with cells contained in cell locator. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId, vtkIdType &cellId)
| Return intersection point (if any) AND the cell which was intersected by the finite line. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId, vtkIdType &cellId, vtkGenericCell *cell)
| Return intersection point (if any) AND the cell which was intersected by the finite line. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], vtkPoints *points, vtkIdList *cellIds)
| Take the passed line segment and intersect it with the data set. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, vtkPoints *points, vtkIdList *cellIds)
| Take the passed line segment and intersect it with the data set. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, vtkPoints *points, vtkIdList *cellIds, vtkGenericCell *cell)
| Take the passed line segment and intersect it with the data set. More...
virtual void | SetDivisions (int, int, int)
| Set the number of divisions in x-y-z directions. More...
virtual void | SetDivisions (int[3])
| Set the number of divisions in x-y-z directions. More...
virtual int * | GetDivisions ()
| Set the number of divisions in x-y-z directions. More...
virtual void | GetDivisions (int data[3])
| Set the number of divisions in x-y-z directions. More...
virtual void | SetMaxNumberOfBuckets (vtkIdType)
| Set the maximum number of buckets in the locator. More...
virtual vtkIdType | GetMaxNumberOfBuckets ()
| Set the maximum number of buckets in the locator. More...
virtual void | SetUseDiagonalLengthTolerance (bool)
| These methods are deprecated. More...
virtual bool | GetUseDiagonalLengthTolerance ()
| These methods are deprecated. More...
virtual void | UseDiagonalLengthToleranceOn ()
| These methods are deprecated. More...
virtual void | UseDiagonalLengthToleranceOff ()
| These methods are deprecated. More...
void | GenerateRepresentation (int level, vtkPolyData *pd) override
| Satisfy vtkLocator abstract interface. More...
void | FreeSearchStructure () override
| Satisfy vtkLocator abstract interface. More...
void | BuildLocator () override
| Satisfy vtkLocator abstract interface. More...
void | ForceBuildLocator () override
| Satisfy vtkLocator abstract interface. More...
Public Member Functions inherited from vtkAbstractCellLocator
vtkAbstractCellLocator * | NewInstance () const
void | ComputeCellBounds ()
| This function can be used either internally or externally to compute only the cached cell bounds if CacheCellBounds is on. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId)
| Return intersection point (if any) of finite line with cells contained in cell locator. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId, vtkIdType &cellId)
| Return intersection point (if any) AND the cell which was intersected by the finite line. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], vtkPoints *points, vtkIdList *cellIds)
| Take the passed line segment and intersect it with the data set. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, vtkPoints *points, vtkIdList *cellIds)
| Take the passed line segment and intersect it with the data set. More...
virtual void | FindClosestPoint (const double x[3], double closestPoint[3], vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point and the cell which is closest to the point x. More...
virtual vtkIdType | FindClosestPointWithinRadius (double x[3], double radius, double closestPoint[3], vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point within a specified radius and the cell which is closest to the point x. More...
virtual vtkIdType | FindClosestPointWithinRadius (double x[3], double radius, double closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point within a specified radius and the cell which is closest to the point x. More...
virtual vtkIdType | FindCell (double x[3])
| Returns the Id of the cell containing the point, returns -1 if no cell found. More...
virtual void | SetNumberOfCellsPerNode (int)
| Specify the preferred/maximum number of cells in each node/bucket. More...
virtual int | GetNumberOfCellsPerNode ()
| Specify the preferred/maximum number of cells in each node/bucket. More...
virtual void | SetCacheCellBounds (vtkTypeBool)
| Boolean controls whether the bounds of each cell are computed only once and then saved. More...
virtual vtkTypeBool | GetCacheCellBounds ()
| Boolean controls whether the bounds of each cell are computed only once and then saved. More...
virtual void | CacheCellBoundsOn ()
| Boolean controls whether the bounds of each cell are computed only once and then saved. More...
virtual void | CacheCellBoundsOff ()
| Boolean controls whether the bounds of each cell are computed only once and then saved. More...
virtual void | SetRetainCellLists (vtkTypeBool)
| Boolean controls whether to maintain list of cells in each node. More...
virtual vtkTypeBool | GetRetainCellLists ()
| Boolean controls whether to maintain list of cells in each node. More...
virtual void | RetainCellListsOn ()
| Boolean controls whether to maintain list of cells in each node. More...
virtual void | RetainCellListsOff ()
| Boolean controls whether to maintain list of cells in each node. More...
virtual void | SetLazyEvaluation (vtkTypeBool)
| Most Locators build their search structures during BuildLocator but some may delay construction until it is actually needed. More...
virtual vtkTypeBool | GetLazyEvaluation ()
| Most Locators build their search structures during BuildLocator but some may delay construction until it is actually needed. More...
virtual void | LazyEvaluationOn ()
| Most Locators build their search structures during BuildLocator but some may delay construction until it is actually needed. More...
virtual void | LazyEvaluationOff ()
| Most Locators build their search structures during BuildLocator but some may delay construction until it is actually needed. More...
virtual vtkIdType | FindCell (double x[3], double tol2, vtkGenericCell *GenCell, double pcoords[3], double *weights)
| Find the cell containing a given point. More...
virtual vtkIdType | FindCell (double x[3], double tol2, vtkGenericCell *GenCell, int &subId, double pcoords[3], double *weights)
| Find the cell containing a given point. More...
Public Member Functions inherited from vtkLocator
virtual void | Update ()
| Cause the locator to rebuild itself if it or its input dataset has changed. More...
virtual void | Initialize ()
| Initialize locator. More...
virtual void | SetDataSet (vtkDataSet *)
| Build the locator from the points/cells defining this dataset. More...
virtual vtkDataSet * | GetDataSet ()
| Build the locator from the points/cells defining this dataset. More...
virtual void | SetMaxLevel (int)
| Set the maximum allowable level for the tree. More...
virtual int | GetMaxLevel ()
| Set the maximum allowable level for the tree. More...
virtual int | GetLevel ()
| Get the level of the locator (determined automatically if Automatic is true). More...
virtual void | SetAutomatic (vtkTypeBool)
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual vtkTypeBool | GetAutomatic ()
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual void | AutomaticOn ()
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual void | AutomaticOff ()
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual void | SetTolerance (double)
| Specify absolute tolerance (in world coordinates) for performing geometric operations. More...
virtual double | GetTolerance ()
| Specify absolute tolerance (in world coordinates) for performing geometric operations. More...
virtual void | SetUseExistingSearchStructure (vtkTypeBool)
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual vtkTypeBool | GetUseExistingSearchStructure ()
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual void | UseExistingSearchStructureOn ()
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual void | UseExistingSearchStructureOff ()
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual vtkMTimeType | GetBuildTime ()
| Return the time of the last data structure build. More...
bool | UsesGarbageCollector () const override
| Handle the PointSet <-> Locator loop. More...
vtkLocator * | NewInstance () const
| Standard type and print methods. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Protected Member Functions
| vtkStaticCellLocator ()
| ~vtkStaticCellLocator () override
void | BuildLocatorInternal () override
| This function is not pure virtual to maintain backwards compatibility. More...
Protected Member Functions inherited from vtkAbstractCellLocator
| vtkAbstractCellLocator ()
| ~vtkAbstractCellLocator () override
void | UpdateInternalWeights ()
| To be called in `FindCell(double[3])`. More...
void | GetCellBounds (vtkIdType cellId, double *&cellBoundsPtr)
virtual bool | StoreCellBounds ()
| This command is used internally by the locator to copy all cell Bounds into the internal CellBounds array. More...
virtual void | FreeCellBounds ()
| This command is used internally by the locator to copy all cell Bounds into the internal CellBounds array. More...
Protected Member Functions inherited from vtkLocator
| vtkLocator ()
| ~vtkLocator () override
void | ReportReferences (vtkGarbageCollector *) override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | Bounds [6]
int | Divisions [3]
double | H [3]
vtkIdType | MaxNumberOfBuckets
bool | LargeIds
bool | UseDiagonalLengthTolerance = false
vtkCellBinner * | Binner
vtkCellProcessor * | Processor
Protected Attributes inherited from vtkAbstractCellLocator
int | NumberOfCellsPerNode
vtkTypeBool | RetainCellLists
vtkTypeBool | CacheCellBounds
vtkNew< vtkGenericCell > | GenericCell
std::shared_ptr< std::vector< double > > | CellBoundsSharedPtr
double * | CellBounds
vtkTimeStamp | WeightsTime
| This time stamp helps us decide if we want to update internal `Weights` array size. More...
std::vector< double > | Weights
| This array is resized so that it can fit points from the cell hosting the most in the input data set. More...
Protected Attributes inherited from vtkLocator
vtkDataSet * | DataSet
vtkTypeBool | UseExistingSearchStructure
vtkTypeBool | Automatic
double | Tolerance
int | MaxLevel
int | Level
vtkTimeStamp | BuildTime
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Friends
struct | vtkCellBinner
struct | vtkCellProcessor
typedef vtkAbstractCellLocator | Superclass
| Standard methods to instantiate, print and obtain type-related information. More...
static vtkStaticCellLocator * | New ()
| Standard methods to instantiate, print and obtain type-related information. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods to instantiate, print and obtain type-related information. More...
static vtkStaticCellLocator * | SafeDownCast (vtkObjectBase *o)
| Standard methods to instantiate, print and obtain type-related information. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods to instantiate, print and obtain type-related information. More...
vtkStaticCellLocator * | NewInstance () const
| Standard methods to instantiate, print and obtain type-related information. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods to instantiate, print and obtain type-related information. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods to instantiate, print and obtain type-related information. More...

## Additional Inherited Members
Public Types inherited from vtkAbstractCellLocator
typedef vtkLocator | Superclass
Public Types inherited from vtkLocator
typedef vtkObject | Superclass
| Standard type and print methods. More...
Static Public Member Functions inherited from vtkAbstractCellLocator
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractCellLocator * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkLocator
static vtkTypeBool | IsTypeOf (const char *type)
| Standard type and print methods. More...
static vtkLocator * | SafeDownCast (vtkObjectBase *o)
| Standard type and print methods. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...
Static Protected Member Functions inherited from vtkAbstractCellLocator
static bool | IsInBounds (const double bounds[6], const double x[3], double tol=0.0)
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

perform fast cell location operations

vtkStaticCellLocator is a type of vtkAbstractCellLocator that accelerates certain operations when performing spatial operations on cells. These operations include finding a point that contains a cell, and intersecting cells with a line.

vtkStaticCellLocator is an accelerated version of vtkCellLocator. It is threaded (via vtkSMPTools), and supports one-time static construction (i.e., incremental cell insertion is not supported).

Warning
  vtkStaticCellLocator utilizes the following parent class parameters:
  - Automatic (default true)
  - NumberOfCellsPerNode (default 10)
  - UseExistingSearchStructure (default false)

vtkStaticCellLocator does NOT utilize the following parameters:

- CacheCellBounds (always cached)
- Tolerance
- Level
- MaxLevel
- RetainCellLists

Warning
  This class is templated. It may run slower than serial execution if the code is not optimized during compilation. Build in Release or ReleaseWithDebugInfo.

See also
  vtkAbstractCellLocator vtkCellLocator vtkCellTreeLocator vtkModifiedBSPTree vtkOBBTree

Tests:
  vtkStaticCellLocator (Tests)

Definition at line 52 of file vtkStaticCellLocator.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkAbstractCellLocator vtkStaticCellLocator::Superclass

Standard methods to instantiate, print and obtain type-related information.

Definition at line 63 of file vtkStaticCellLocator.h.

## Constructor & Destructor Documentation

## ◆ vtkStaticCellLocator()

vtkStaticCellLocator::vtkStaticCellLocator | ( |  | ) |
| protected

## ◆ ~vtkStaticCellLocator()

vtkStaticCellLocator::~vtkStaticCellLocator | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkStaticCellLocator* vtkStaticCellLocator::New | ( |  | ) |
| static

Standard methods to instantiate, print and obtain type-related information.

## ◆ IsTypeOf()

static vtkTypeBool vtkStaticCellLocator::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods to instantiate, print and obtain type-related information.

## ◆ IsA()

virtual vtkTypeBool vtkStaticCellLocator::IsA | ( | const char * | type | ) |
| virtual

Standard methods to instantiate, print and obtain type-related information.

Reimplemented from vtkAbstractCellLocator.

## ◆ SafeDownCast()

static vtkStaticCellLocator* vtkStaticCellLocator::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods to instantiate, print and obtain type-related information.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkStaticCellLocator::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods to instantiate, print and obtain type-related information.

Reimplemented from vtkAbstractCellLocator.

## ◆ NewInstance()

vtkStaticCellLocator* vtkStaticCellLocator::NewInstance | ( |  | ) | const

Standard methods to instantiate, print and obtain type-related information.

## ◆ PrintSelf()

void vtkStaticCellLocator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods to instantiate, print and obtain type-related information.

Reimplemented from vtkAbstractCellLocator.

## ◆ SetDivisions() [1/2]

virtual void vtkStaticCellLocator::SetDivisions | ( | int | ,
|  | int | ,
|  | int |
| ) |  |
| virtual

Set the number of divisions in x-y-z directions.

If the Automatic data member is enabled, the Divisions are set according to the NumberOfCellsPerNode and MaxNumberOfBuckets data members. The number of divisions must be >= 1 in each direction.

## ◆ SetDivisions() [2/2]

virtual void vtkStaticCellLocator::SetDivisions | ( | int | [3] | ) |
| virtual

Set the number of divisions in x-y-z directions.

If the Automatic data member is enabled, the Divisions are set according to the NumberOfCellsPerNode and MaxNumberOfBuckets data members. The number of divisions must be >= 1 in each direction.

## ◆ GetDivisions() [1/2]

virtual int* vtkStaticCellLocator::GetDivisions | ( |  | ) |
| virtual

Set the number of divisions in x-y-z directions.

If the Automatic data member is enabled, the Divisions are set according to the NumberOfCellsPerNode and MaxNumberOfBuckets data members. The number of divisions must be >= 1 in each direction.

## ◆ GetDivisions() [2/2]

virtual void vtkStaticCellLocator::GetDivisions | ( | int | data[3] | ) |
| virtual

Set the number of divisions in x-y-z directions.

If the Automatic data member is enabled, the Divisions are set according to the NumberOfCellsPerNode and MaxNumberOfBuckets data members. The number of divisions must be >= 1 in each direction.

## ◆ SetMaxNumberOfBuckets()

virtual void vtkStaticCellLocator::SetMaxNumberOfBuckets | ( | vtkIdType |  | ) |
| virtual

Set the maximum number of buckets in the locator.

By default the value is set to VTK_INT_MAX. Note that there are significant performance implications at work here. If the number of buckets is set very large (meaning > VTK_INT_MAX) then internal sorting may be performed using 64-bit integers (which is much slower than using a 32-bit int). Of course, memory requirements may dramatically increase as well. It is recommended that the default value be used; but for extremely large data it may be desired to create a locator with an exceptionally large number of buckets. Note also that during initialization of the locator if the MaxNumberOfBuckets threshold is exceeded, the Divisions are scaled down in such a way as not to exceed the MaxNumberOfBuckets proportionally to the size of the bounding box in the x-y-z directions.

## ◆ GetMaxNumberOfBuckets()

virtual vtkIdType vtkStaticCellLocator::GetMaxNumberOfBuckets | ( |  | ) |
| virtual

Set the maximum number of buckets in the locator.

By default the value is set to VTK_INT_MAX. Note that there are significant performance implications at work here. If the number of buckets is set very large (meaning > VTK_INT_MAX) then internal sorting may be performed using 64-bit integers (which is much slower than using a 32-bit int). Of course, memory requirements may dramatically increase as well. It is recommended that the default value be used; but for extremely large data it may be desired to create a locator with an exceptionally large number of buckets. Note also that during initialization of the locator if the MaxNumberOfBuckets threshold is exceeded, the Divisions are scaled down in such a way as not to exceed the MaxNumberOfBuckets proportionally to the size of the bounding box in the x-y-z directions.

## ◆ GetLargeIds()

bool vtkStaticCellLocator::GetLargeIds | ( |  | ) |
| inline

Inform the user as to whether large ids are being used.

This flag only has meaning after the locator has been built. Large ids are used when the number of binned points, or the number of bins, is >= the maximum number of buckets (specified by the user). Note that LargeIds are only available on 64-bit architectures.

Definition at line 104 of file vtkStaticCellLocator.h.

## ◆ SetUseDiagonalLengthTolerance()

virtual void vtkStaticCellLocator::SetUseDiagonalLengthTolerance | ( | bool |  | ) |
| virtual

These methods are deprecated.

This flag was used in internally in conjunction with Tolerance, which has been removed because nobody was using it, and it would lead to really slow performance if the dataset was small bounds-wise. Tolerance was originally introduced to solve IntersectionWithLine issues the existed before. These issues have been resolved by using double tolerance internally.

When set to true, the CellBinner will multiply the locator tolerance by the diagonal length of the dataset to compute its own tolerance. When not, it uses the locator tolerance directly. Default is false.

## ◆ GetUseDiagonalLengthTolerance()

virtual bool vtkStaticCellLocator::GetUseDiagonalLengthTolerance | ( |  | ) |
| virtual

These methods are deprecated.

This flag was used in internally in conjunction with Tolerance, which has been removed because nobody was using it, and it would lead to really slow performance if the dataset was small bounds-wise. Tolerance was originally introduced to solve IntersectionWithLine issues the existed before. These issues have been resolved by using double tolerance internally.

When set to true, the CellBinner will multiply the locator tolerance by the diagonal length of the dataset to compute its own tolerance. When not, it uses the locator tolerance directly. Default is false.

## ◆ UseDiagonalLengthToleranceOn()

virtual void vtkStaticCellLocator::UseDiagonalLengthToleranceOn | ( |  | ) |
| inlinevirtual

These methods are deprecated.

This flag was used in internally in conjunction with Tolerance, which has been removed because nobody was using it, and it would lead to really slow performance if the dataset was small bounds-wise. Tolerance was originally introduced to solve IntersectionWithLine issues the existed before. These issues have been resolved by using double tolerance internally.

When set to true, the CellBinner will multiply the locator tolerance by the diagonal length of the dataset to compute its own tolerance. When not, it uses the locator tolerance directly. Default is false.

Definition at line 123 of file vtkStaticCellLocator.h.

## ◆ UseDiagonalLengthToleranceOff()

virtual void vtkStaticCellLocator::UseDiagonalLengthToleranceOff | ( |  | ) |
| inlinevirtual

These methods are deprecated.

This flag was used in internally in conjunction with Tolerance, which has been removed because nobody was using it, and it would lead to really slow performance if the dataset was small bounds-wise. Tolerance was originally introduced to solve IntersectionWithLine issues the existed before. These issues have been resolved by using double tolerance internally.

When set to true, the CellBinner will multiply the locator tolerance by the diagonal length of the dataset to compute its own tolerance. When not, it uses the locator tolerance directly. Default is false.

Definition at line 132 of file vtkStaticCellLocator.h.

## ◆ IntersectWithLine() [1/8]

int vtkStaticCellLocator::IntersectWithLine | ( | const double | a0[3],
|  | const double | a1[3],
|  | double | tol,
|  | double & | t,
|  | double | x[3],
|  | double | pcoords[3],
|  | int & | subId,
|  | vtkIdType & | cellId,
|  | vtkGenericCell * | cell
| ) |  |
| overridevirtual

Return intersection point (if any) AND the cell which was intersected by the finite line.

The cell is returned as a cell id and as a generic cell.

For other IntersectWithLine signatures, see vtkAbstractCellLocator.

Reimplemented from vtkAbstractCellLocator.

## ◆ IntersectWithLine() [2/8]

int vtkStaticCellLocator::IntersectWithLine | ( | const double | p1[3],
|  | const double | p2[3],
|  | double | tol,
|  | vtkPoints * | points,
|  | vtkIdList * | cellIds,
|  | vtkGenericCell * | cell
| ) |  |
| overridevirtual

Take the passed line segment and intersect it with the data set.

The return value of the function is 0 if no intersections were found. For each intersection with the bounds of a cell or with a cell (if a cell is provided), the points and cellIds have the relevant information added sorted by t. If points or cellIds are nullptr pointers, then no information is generated for that list.

For other IntersectWithLine signatures, see vtkAbstractCellLocator.

Reimplemented from vtkAbstractCellLocator.

## ◆ FindClosestPoint() [1/3]

void vtkStaticCellLocator::FindClosestPoint | ( | const double | x[3],
|  | double | closestPoint[3],
|  | vtkGenericCell * | cell,
|  | vtkIdType & | cellId,
|  | int & | subId,
|  | double & | dist2
| ) |  |
| inlineoverridevirtual

Return the closest point and the cell which is closest to the point x.

The closest point is somewhere on a cell, it need not be one of the vertices of the cell.

Reimplemented from vtkAbstractCellLocator to showcase that it's a supported function.

For other FindClosestPoint signatures, see vtkAbstractCellLocator.

Reimplemented from vtkAbstractCellLocator.

Definition at line 178 of file vtkStaticCellLocator.h.

## ◆ FindClosestPointWithinRadius() [1/4]

vtkIdType vtkStaticCellLocator::FindClosestPointWithinRadius | ( | double | x[3],
|  | double | radius,
|  | double | closestPoint[3],
|  | vtkGenericCell * | cell,
|  | vtkIdType & | cellId,
|  | int & | subId,
|  | double & | dist2,
|  | int & | inside
| ) |  |
| overridevirtual

Return the closest point within a specified radius and the cell which is closest to the point x.

The closest point is somewhere on a cell, it need not be one of the vertices of the cell. This method returns 1 if a point is found within the specified radius. If there are no cells within the specified radius, the method returns 0 and the values of closestPoint, cellId, subId, and dist2 are undefined. If a closest point is found, inside returns the return value of the EvaluatePosition call to the closest cell; inside(=1) or outside(=0).

Reimplemented from vtkAbstractCellLocator.

## ◆ FindCellsWithinBounds()

void vtkStaticCellLocator::FindCellsWithinBounds | ( | double * | bbox,
|  | vtkIdList * | cells
| ) |  |
| overridevirtual

Return a list of unique cell ids inside of a given bounding box.

The user must provide the vtkIdList to populate.

Reimplemented from vtkAbstractCellLocator.

## ◆ FindCellsAlongLine()

void vtkStaticCellLocator::FindCellsAlongLine | ( | const double | p1[3],
|  | const double | p2[3],
|  | double | tolerance,
|  | vtkIdList * | cellsIds
| ) |  |
| inlineoverridevirtual

Take the passed line segment and intersect it with the data set.

For each intersection with the bounds of a cell, the cellIds have the relevant information added. If cellIds is nullptr pointer, then no information is generated for that list.

Reimplemented from vtkAbstractCellLocator to showcase that it's a supported function.

Reimplemented from vtkAbstractCellLocator.

Definition at line 211 of file vtkStaticCellLocator.h.

## ◆ FindCellsAlongPlane()

void vtkStaticCellLocator::FindCellsAlongPlane | ( | const double | o[3],
|  | const double | n[3],
|  | double | tolerance,
|  | vtkIdList * | cells
| ) |  |
| overridevirtual

Take the passed line segment and intersect it with the data set.

For each intersection with the bounds of a cell, the cellIds have the relevant information added sort by t. If cellIds is nullptr pointer, then no information is generated for that list.

Reimplemented from vtkAbstractCellLocator.

## ◆ FindCell() [1/4]

vtkIdType vtkStaticCellLocator::FindCell | ( | double | x[3],
|  | double | vtkNotUsedtol2,
|  | vtkGenericCell * | GenCell,
|  | int & | subId,
|  | double | pcoords[3],
|  | double * | weights
| ) |  |
| override

Find the cell containing a given point.

returns -1 if no cell found the cell parameters are copied into the supplied variables, a cell must be provided to store the information.

For other FindCell signatures, see vtkAbstractCellLocator.

## ◆ InsideCellBounds()

bool vtkStaticCellLocator::InsideCellBounds | ( | double | x[3],
|  | vtkIdType | cellId
| ) |  |
| overridevirtual

Quickly test if a point is inside the bounds of a particular cell.

This function should be used ONLY after the locator is built.

Reimplemented from vtkAbstractCellLocator.

## ◆ GenerateRepresentation()

void vtkStaticCellLocator::GenerateRepresentation | ( | int | level,
|  | vtkPolyData * | pd
| ) |  |
| overridevirtual

Satisfy vtkLocator abstract interface.

Implements vtkLocator.

## ◆ FreeSearchStructure()

void vtkStaticCellLocator::FreeSearchStructure | ( |  | ) |
| overridevirtual

Satisfy vtkLocator abstract interface.

Implements vtkLocator.

## ◆ BuildLocator()

void vtkStaticCellLocator::BuildLocator | ( |  | ) |
| overridevirtual

Satisfy vtkLocator abstract interface.

Implements vtkLocator.

## ◆ ForceBuildLocator()

void vtkStaticCellLocator::ForceBuildLocator | ( |  | ) |
| overridevirtual

Satisfy vtkLocator abstract interface.

Reimplemented from vtkLocator.

## ◆ ShallowCopy()

void vtkStaticCellLocator::ShallowCopy | ( | vtkAbstractCellLocator * | locator | ) |
| overridevirtual

Shallow copy of a vtkStaticCellLocator.

Reimplemented from vtkAbstractCellLocator.

## ◆ BuildLocatorInternal()

void vtkStaticCellLocator::BuildLocatorInternal | ( |  | ) |
| overrideprotectedvirtual

This function is not pure virtual to maintain backwards compatibility.

Reimplemented from vtkLocator.

## ◆ FindCell() [2/4]

virtual vtkIdType vtkAbstractCellLocator::FindCell

Returns the Id of the cell containing the point, returns -1 if no cell found.

This interface uses a tolerance of zero

THIS FUNCTION IS NOT THREAD SAFE.

## ◆ FindCell() [3/4]

virtual vtkIdType vtkAbstractCellLocator::FindCell

Find the cell containing a given point.

returns -1 if no cell found the cell parameters are copied into the supplied variables, a cell must be provided to store the information.

THIS FUNCTION IS THREAD SAFE.

## ◆ FindCell() [4/4]

virtual vtkIdType vtkAbstractCellLocator::FindCell

## ◆ FindClosestPoint() [2/3]

virtual void vtkAbstractCellLocator::FindClosestPoint

Return the closest point and the cell which is closest to the point x.

The closest point is somewhere on a cell, it need not be one of the vertices of the cell.

A vtkAbstractCellLocator subclass needs to implement FindClosestPointWithinRadius which is used internally to implement FindClosestPoint.

THIS FUNCTION IS NOT THREAD SAFE.

## ◆ FindClosestPoint() [3/3]

virtual void vtkAbstractCellLocator::FindClosestPoint

Return the closest point and the cell which is closest to the point x.

The closest point is somewhere on a cell, it need not be one of the vertices of the cell.

A vtkAbstractCellLocator subclass needs to implement FindClosestPointWithinRadius which is used internally to implement FindClosestPoint.

This function takes in a vtkGenericCell to avoid using the internal vtkGenericCell.

THIS FUNCTION IS THREAD SAFE.

## ◆ FindClosestPointWithinRadius() [2/4]

virtual vtkIdType vtkAbstractCellLocator::FindClosestPointWithinRadius

Return the closest point within a specified radius and the cell which is closest to the point x.

The closest point is somewhere on a cell, it need not be one of the vertices of the cell. This method returns 1 if a point is found within the specified radius. If there are no cells within the specified radius, the method returns 0 and the values of closestPoint, cellId, subId, and dist2 are undefined.

THIS FUNCTION IS NOT THREAD SAFE.

## ◆ FindClosestPointWithinRadius() [3/4]

virtual vtkIdType vtkAbstractCellLocator::FindClosestPointWithinRadius

Return the closest point within a specified radius and the cell which is closest to the point x.

The closest point is somewhere on a cell, it need not be one of the vertices of the cell. This method returns 1 if a point is found within the specified radius. If there are no cells within the specified radius, the method returns 0 and the values of closestPoint, cellId, subId, and dist2 are undefined.

This function takes in a vtkGenericCell to avoid using the internal vtkGenericCell.

THIS FUNCTION IS THREAD SAFE.

## ◆ FindClosestPointWithinRadius() [4/4]

virtual vtkIdType vtkAbstractCellLocator::FindClosestPointWithinRadius

Return the closest point within a specified radius and the cell which is closest to the point x.

The closest point is somewhere on a cell, it need not be one of the vertices of the cell. This method returns 1 if a point is found within the specified radius. If there are no cells within the specified radius, the method returns 0 and the values of closestPoint, cellId, subId, and dist2 are undefined. If a closest point is found, inside returns the return value of the EvaluatePosition call to the closest cell; inside(=1) or outside(=0).

This function takes in a vtkGenericCell to avoid using the internal vtkGenericCell.

THIS FUNCTION IS THREAD SAFE.

## ◆ IntersectWithLine() [3/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Return intersection point (if any) of finite line with cells contained in cell locator.

See vtkCell.h parameters documentation.

THIS FUNCTION IS NOT THREAD SAFE.

## ◆ IntersectWithLine() [4/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Return intersection point (if any) AND the cell which was intersected by the finite line.

THIS FUNCTION IS NOT THREAD SAFE.

## ◆ IntersectWithLine() [5/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Return intersection point (if any) AND the cell which was intersected by the finite line.

The cell is returned as a cell id and as a generic cell.

This function takes in a vtkGenericCell to avoid using the internal vtkGenericCell.

THIS FUNCTION IS THREAD SAFE.

## ◆ IntersectWithLine() [6/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Take the passed line segment and intersect it with the data set.

The return value of the function is 0 if no intersections were found, -1 if point 'a0' lies inside the closed surface, or +1 if point 'a0' lies outside the closed surface. This method assumes that the data set is a vtkPolyData that describes a closed surface, and the intersection points that are returned in 'points' alternate between entrance points and exit points.

Either 'points' or 'cellIds' can be set to nullptr if you don't want to receive that information.

This method is only implemented in vtkOBBTree.

THIS FUNCTION IS THREAD SAFE.

## ◆ IntersectWithLine() [7/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Take the passed line segment and intersect it with the data set.

The return value of the function is 0 if no intersections were found. For each intersection with a cell, the points and cellIds have the relevant information added sorted by t. If points or cellIds are nullptr pointers, then no information is generated for that list.

THIS FUNCTION IS NOT THREAD SAFE.

## ◆ IntersectWithLine() [8/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Take the passed line segment and intersect it with the data set.

The return value of the function is 0 if no intersections were found. For each intersection with the bounds of a cell or with a cell (if a cell is provided), the points and cellIds have the relevant information added sorted by t. If points or cellIds are nullptr pointers, then no information is generated for that list.

This function takes in a vtkGenericCell to avoid using the internal vtkGenericCell.

THIS FUNCTION IS THREAD SAFE.

## Friends And Related Function Documentation

## ◆ vtkCellBinner

friend struct vtkCellBinner
| friend

Definition at line 54 of file vtkStaticCellLocator.h.

## ◆ vtkCellProcessor

friend struct vtkCellProcessor
| friend

Definition at line 55 of file vtkStaticCellLocator.h.

## Member Data Documentation

## ◆ Bounds

double vtkStaticCellLocator::Bounds[6]
| protected

Definition at line 263 of file vtkStaticCellLocator.h.

## ◆ Divisions

int vtkStaticCellLocator::Divisions[3]
| protected

Definition at line 264 of file vtkStaticCellLocator.h.

## ◆ H

double vtkStaticCellLocator::H[3]
| protected

Definition at line 265 of file vtkStaticCellLocator.h.

## ◆ MaxNumberOfBuckets

vtkIdType vtkStaticCellLocator::MaxNumberOfBuckets
| protected

Definition at line 267 of file vtkStaticCellLocator.h.

## ◆ LargeIds

bool vtkStaticCellLocator::LargeIds
| protected

Definition at line 268 of file vtkStaticCellLocator.h.

## ◆ UseDiagonalLengthTolerance

bool vtkStaticCellLocator::UseDiagonalLengthTolerance = false
| protected

Definition at line 271 of file vtkStaticCellLocator.h.

## ◆ Binner

vtkCellBinner* vtkStaticCellLocator::Binner
| protected

Definition at line 274 of file vtkStaticCellLocator.h.

## ◆ Processor

vtkCellProcessor* vtkStaticCellLocator::Processor
| protected

Definition at line 275 of file vtkStaticCellLocator.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkStaticCellLocator.h